"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _ParameterControl = _interopRequireDefault(require("./ParameterControl"));

var _ExtendableContainer = _interopRequireDefault(require("../../base/ExtendableContainer"));

var _Logger = _interopRequireDefault(require("../../../systems/Logger"));

var _Module2 = _interopRequireDefault(require("../../Module"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

Object.defineProperty(Object.prototype, "makeArray", {
  enumerable: false,
  value: function value(obj) {
    var array = [];

    for (var key in obj) {
      array.push(obj[key]);
    }

    return array;
  }
}); //import './ModulesList.css';

var ModulesList =
/*#__PURE__*/
function (_Module) {
  _inherits(ModulesList, _Module);

  function ModulesList(props) {
    var _this;

    _classCallCheck(this, ModulesList);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ModulesList).call(this, props));
    _this.state = {
      modules: []
    }; //console.log(props.list);

    return _this;
  }

  _createClass(ModulesList, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps() {
      this.refresh();
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      _get(_getPrototypeOf(ModulesList.prototype), "componentDidMount", this).call(this);

      this.refresh();
    }
  }, {
    key: "parseModules",
    value: function parseModules(modules) {
      var mods = modules.map(function (m) {
        return [m.Namespace || "General", m.Category || 'Uncategorized', m.name];
      });
      var result = {
        'Unordered': []
      };
      mods.forEach(function (names, index) {
        var temp = result;

        for (var i = 0; i < names.length - 1; i++) {
          if (!temp[names[i]]) temp[names[i]] = {};
          temp = temp[names[i]];
        }

        if (!temp.items) temp.items = [];
        temp.items.push(names[names.length - 1]);
      }); // console.log("ModuleStructure: " , result);

      return result;
    }
  }, {
    key: "makeFolder",
    value: function makeFolder(dictionary) {
      var path = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "";
      var res = [];

      for (var key in dictionary) {
        if (key === 'items') {
          for (var i in dictionary[key]) {
            // console.log(dictionary[key][i])
            res.push(_react.default.createElement(_ParameterControl.default, {
              className: this.props.controlClassName,
              module: this.props.list[path + dictionary[key][i]],
              name: i,
              key: i
            }));
          }

          continue;
        }

        res.push(_react.default.createElement(_ExtendableContainer.default, {
          header: key,
          key: key,
          className: this.props.className
        }, this.makeFolder(dictionary[key], path + key)));
      }

      return res;
    }
  }, {
    key: "refresh",
    value: function refresh() {
      var modules = Object.makeArray(this.props.list) || [];
      var array = [];
      var dictionary = this.parseModules(modules); // console.log("dictionary");
      // console.log(dictionary);

      var mods = this.makeFolder(dictionary); // let folders = Object.keys(modules).reduce((a,b) => {
      // 	a[modules[b].Category] = [...(a[modules[b].Category] || []), modules[b]];
      // 	return a;
      // }, {});

      this.setState({
        modules: mods,
        folders: []
      });
    }
  }, {
    key: "render",
    value: function render() {
      return this.state.modules || 'NO MODS';
    }
  }]);

  return ModulesList;
}(_Module2.default);

var _default = ModulesList;
exports.default = _default;