"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _Module2 = _interopRequireDefault(require("../Module"));

var _ = _interopRequireDefault(require("../"));

var _Logger = _interopRequireDefault(require("../../systems/Logger"));

var _Systems = _interopRequireDefault(require("../../systems/Systems"));

var _CoreSystem = _interopRequireDefault(require("../../systems/CoreSystem"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var SubSystem =
/*#__PURE__*/
function (_Module) {
  _inherits(SubSystem, _Module);

  function SubSystem(props) {
    var _this;

    _classCallCheck(this, SubSystem);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(SubSystem).call(this, props));
    _this.view = '';

    _this.import.onUpdate(function (data) {
      _this.load(data);

      _this.forceUpdate();
    });

    _this.load(_this.import.value);

    _this.loadIO();

    return _this;
  }

  _createClass(SubSystem, [{
    key: "load",
    value: function load(data) {
      this.success = false;

      try {
        this.data = JSON.parse(data);
        var Core = new _CoreSystem.default(this.getId());

        _Systems.default.addSystem(Core);

        Core.import(this.data);
        this.success = true;
      } catch (e) {
        _Logger.default.warning("Cannot Parse import field! No json!", e);
      }
    }
  }, {
    key: "loadIO",
    value: function loadIO() {
      var _this2 = this;

      var Core = _Systems.default.getSystem(this.getId());

      var _loop = function _loop(key) {
        _this2.generateOutput(_this2.LinkManager.addOutputRef(_this2[key] || (_this2.props.outputs[key] ? _objectSpread({}, _this2.props.outputs[key], {
          pid: _this2.getId()
        }) : null) || Core.inputs[key]), key);

        var Input = Core.getInput(key);
        Input.onUpdate(function () {
          return _this2[key].set(Input.value);
        });
      };

      for (var key in Core.inputs) {
        _loop(key);
      }

      var _loop2 = function _loop2(key) {
        _this2.generateInput(_this2.LinkManager.addInputRef(_this2[key] || (_this2.props.inputs[key] ? _objectSpread({}, _this2.props.inputs[key], {
          pid: _this2.getId()
        }) : null) || Core.outputs[key]), key);

        var Output = Core.getOutput(key);
        if (_this2[key].value) Output.set(_this2[key].value);

        _this2[key].onUpdate(function () {
          return Output.set(_this2[key].value);
        });
      };

      for (var key in Core.outputs) {
        _loop2(key);
      }
    }
  }, {
    key: "render",
    value: function render() {
      if (!this.success) return _react.default.createElement("div", null, "SubSystem", _get(_getPrototypeOf(SubSystem.prototype), "render", this).call(this));
      return _react.default.createElement("div", {
        className: "SubSystem"
      }, _Systems.default.getSystem(this.getId()).renderModules(), _get(_getPrototypeOf(SubSystem.prototype), "render", this).call(this));
    }
  }]);

  return SubSystem;
}(_Module2.default);

SubSystem.EditPosition = "top-right";
SubSystem.Inputs = {
  import: {
    type: _Module2.default.Types.Text,
    defaultValue: "{}"
  }
};
SubSystem.Category = "Subsystem";
var _default = SubSystem;
exports.default = _default;