"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _Module2 = _interopRequireDefault(require("../Module"));

var _Link = _interopRequireDefault(require("./Link.js"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Breadcrumb =
/*#__PURE__*/
function (_Module) {
  _inherits(Breadcrumb, _Module);

  function Breadcrumb(props) {
    _classCallCheck(this, Breadcrumb);

    return _possibleConstructorReturn(this, _getPrototypeOf(Breadcrumb).call(this, props));
  }

  _createClass(Breadcrumb, [{
    key: "render",
    value: function render() {
      var _this = this;

      var routes = this.RoutingSystem.getRoutesRegs();
      var route = this.RoutingSystem.getRoute();
      var url = route.url || '';
      var arr = [];

      for (var i in routes) {
        if (routes[i].reg.test(url)) {
          arr.push(routes[i]);
        }
      }

      var narr = arr.sort(function (a, b) {
        return a.url.length - b.url.length;
      });
      var res = narr.map(function (item, indx) {
        return _react.default.createElement("li", {
          key: indx,
          className: "breadcrumb-item"
        }, _react.default.createElement(_Link.default, {
          link: item.id
        }, _this.RoutingSystem.getRouteName(item.id)));
      });
      return _react.default.createElement("div", {
        className: this.props.className + ' Breadcrumb '
      }, _react.default.createElement("nav", {
        "aria-label": "breadcrumb"
      }, _react.default.createElement("ol", {
        className: "breadcrumb"
      }, res)), _get(_getPrototypeOf(Breadcrumb.prototype), "render", this).call(this));
    }
  }]);

  return Breadcrumb;
}(_Module2.default);

Breadcrumb.EditPosition = 'top-center';
Breadcrumb.Category = "Layout";
var _default = Breadcrumb;
exports.default = _default;