"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _Module2 = _interopRequireDefault(require("../Module"));

var _Link = _interopRequireDefault(require("./Link.js"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Pagination =
/*#__PURE__*/
function (_Module) {
  _inherits(Pagination, _Module);

  function Pagination(props) {
    var _this;

    _classCallCheck(this, Pagination);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Pagination).call(this, props));

    _this.selected.onUpdate(function () {
      return _this.forceUpdate();
    });

    _this.page.set(_this.selected.value);

    return _this;
  }

  _createClass(Pagination, [{
    key: "go",
    value: function go(page) {
      this.page.set(page);

      if (this.props.onPage) {
        this.props.onPage(page);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var arr = [-2, -1, 0, 1, 2];
      var base = this.selected.value || 1;
      var nums = arr.map(function (item) {
        return item + base;
      });
      return _react.default.createElement("div", {
        className: this.props.className + ' Pagination '
      }, _react.default.createElement("nav", {
        "aria-label": "Page navigation example"
      }, _react.default.createElement("ul", {
        className: "pagination justify-content-end"
      }, _react.default.createElement("li", {
        className: "page-item " + (base > 1 ? '' : 'disabled')
      }, _react.default.createElement("a", {
        className: "page-link",
        href: "#",
        "aria-label": "Previous",
        onClick: function onClick() {
          return _this2.go(base - 1);
        }
      }, _react.default.createElement("span", {
        "aria-hidden": "true"
      }, "\xAB"), _react.default.createElement("span", {
        className: "sr-only"
      }, "Previous"))), nums.map(function (indx) {
        return indx > 0 && indx <= _this2.lastPage.value ? _react.default.createElement("li", {
          key: indx,
          onClick: function onClick() {
            return _this2.go(indx);
          },
          className: "page-item " + (base === indx ? 'active' : '')
        }, _react.default.createElement("a", {
          className: "page-link",
          href: "#"
        }, indx)) : '';
      }), _react.default.createElement("li", {
        className: "page-item " + (base < this.lastPage.value ? '' : 'disabled')
      }, _react.default.createElement("a", {
        className: "page-link",
        href: "#",
        "aria-label": "Next",
        onClick: function onClick() {
          return _this2.go(base + 1);
        }
      }, _react.default.createElement("span", {
        "aria-hidden": "true"
      }, "\xBB"), _react.default.createElement("span", {
        className: "sr-only"
      }, "Next"))))), _get(_getPrototypeOf(Pagination.prototype), "render", this).call(this));
    }
  }]);

  return Pagination;
}(_Module2.default);

Pagination.EditPosition = 'top-right';
Pagination.Category = "Layout";
Pagination.Inputs = {
  selected: {
    type: _Module2.default.Types.Number,
    defaultValue: 1
  },
  lastPage: {
    type: _Module2.default.Types.Number,
    defaultValue: 2
  }
};
Pagination.Outputs = {
  page: {}
};
var _default = Pagination;
exports.default = _default;