"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _Module2 = _interopRequireDefault(require("../Module"));

var _ExtendableContainer = _interopRequireDefault(require("../base/ExtendableContainer"));

var _ModuleUtilities = require("../ModuleUtilities");

var _reactFontawesome = require("@fortawesome/react-fontawesome");

var _reactMaterialize = require("react-materialize");

var _reactJsonView = _interopRequireDefault(require("react-json-view"));

require("./DummyService.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var DummyService =
/*#__PURE__*/
function (_Module) {
  _inherits(DummyService, _Module);

  function DummyService(props) {
    var _this;

    _classCallCheck(this, DummyService);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(DummyService).call(this, props));
    var dummy = JSON.parse(localStorage.getItem("dummyData") || "{}");
    _this.state = {
      text: _this.input.value || {},
      object: dummy.object || {},
      string: dummy.string || ''
    };

    _this.input.onUpdate(function (v) {
      var text = _this.input.value;

      _this.setState({
        text: text
      });
    });

    _this.string.set(_this.state.string);

    _this.object.set(_this.state.object);

    return _this;
  }

  _createClass(DummyService, [{
    key: "send",
    value: function send(e) {
      if (e.key === "Enter") {
        var v = e.target.value;
        this.string.set(v);
        this.save();
      }
    }
  }, {
    key: "save",
    value: function save() {
      var dummy = {
        string: this.string.value,
        object: this.object.value
      };
      localStorage.setItem("dummyData", JSON.stringify(dummy));
    }
  }, {
    key: "sendJSON",
    value: function sendJSON(e) {
      if (e.key === "Enter") {
        var v = e.target.value;

        try {
          var obj = JSON.parse(v);
          this.object.set(obj);
          this.save();
        } catch (e) {
          console.log("Not JSON", e);
          return;
        }
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      // console.log(this.object);
      return _react.default.createElement("div", {
        className: '',
        key: 'DummyService' + Math.random()
      }, _react.default.createElement("div", {
        className: "row"
      }, this.__renderID()), _react.default.createElement("div", {
        className: "row"
      }, _react.default.createElement(_reactMaterialize.Col, {
        s: 12,
        className: "JSONViewer"
      }, "Input", _react.default.createElement(_reactJsonView.default, {
        src: this.state.text,
        theme: "apathy",
        displayDataTypes: false,
        collapsed: false,
        collapseStringsAfterLength: 7
      })), _react.default.createElement(_reactMaterialize.Col, {
        s: 12,
        className: "JSONViewer"
      }, "Object", _react.default.createElement(_reactJsonView.default, {
        src: this.state.object,
        onAdd: function onAdd(add) {
          _this2.object.set(add.new_value);

          _this2.save();

          _this2.setState({
            object: add.new_value
          });
        },
        theme: "apathy",
        onEdit: function onEdit(add) {
          _this2.object.set(add.updated_src);

          _this2.save();

          _this2.setState({
            object: add.updated_src
          });
        },
        onDelete: function onDelete(add) {
          _this2.object.set(add.updated_src);

          _this2.save();

          _this2.setState({
            object: add.updated_src
          });
        },
        displayDataTypes: false,
        enableClipboard: false,
        collapsed: true,
        collapseStringsAfterLength: 7
      })), _react.default.createElement(_reactMaterialize.Col, {
        s: 12,
        className: "input-field"
      }, "String", _react.default.createElement("textarea", {
        type: "textarea",
        className: "white materialize-textarea",
        onKeyPress: function onKeyPress(e) {
          return _this2.send(e);
        },
        defaultValue: this.state.string
      }))), _react.default.createElement("div", {
        className: "row"
      }, _react.default.createElement("div", {
        className: "col s12"
      }, "Connections"), _react.default.createElement("div", {
        className: "col s12"
      }, _react.default.createElement(_ModuleUtilities.OutputLink, {
        output: this.object
      })), _react.default.createElement("div", {
        className: "col s12"
      }, _react.default.createElement(_ModuleUtilities.OutputLink, {
        output: this.string
      })), _react.default.createElement("div", {
        className: "col s12"
      }, _react.default.createElement(_ModuleUtilities.InputLink, {
        input: this.input
      }))), _react.default.createElement("div", {
        className: "row"
      }), _get(_getPrototypeOf(DummyService.prototype), "render", this).call(this));
    }
  }]);

  return DummyService;
}(_Module2.default);

DummyService.Outputs = {
  object: {},
  string: {}
};
DummyService.Inputs = {
  input: {
    type: _Module2.default.Types.Link
  }
};
DummyService.Category = "Services";
var _default = DummyService;
exports.default = _default;