"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _Module2 = _interopRequireDefault(require("../Module"));

var _ExtendableContainer = _interopRequireDefault(require("../base/ExtendableContainer"));

var _ModuleUtilities = require("../ModuleUtilities");

var _reactFontawesome = require("@fortawesome/react-fontawesome");

require("./ModuleServiceInfo.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var ModuleServiceInfo =
/*#__PURE__*/
function (_Module) {
  _inherits(ModuleServiceInfo, _Module);

  function ModuleServiceInfo(props) {
    var _this;

    _classCallCheck(this, ModuleServiceInfo);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ModuleServiceInfo).call(this, props));
    _this.state = {
      modid: '',
      route: ''
    };
    return _this;
  }

  _createClass(ModuleServiceInfo, [{
    key: "loadModule",
    value: function loadModule(mod) {
      var answer = prompt("Module ID: ");
      if (!answer) return;
      mod.id = answer;
      this.ModuleSystem.loadModule(mod);
      this.CoreSystem.refresh(true);
    }
  }, {
    key: "removeModule",
    value: function removeModule(mod) {
      this.ModuleSystem.remove(mod);
      this.CoreSystem.refresh();
      this.forceUpdate();
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var modules = this.ModuleSystem.getModules(); // console.log(modules);

      return _react.default.createElement("div", {
        className: 'ModuleServiceInfo'
      }, _react.default.createElement("div", {
        className: "row"
      }, this.__renderID()), _react.default.createElement("div", {
        className: "row"
      }, _react.default.createElement("div", {
        className: "col s3"
      }, "Modules"), _react.default.createElement("div", {
        className: "col"
      }, modules.length, _react.default.createElement(_ModuleUtilities.InputMarker, {
        onDrop: function onDrop(mod) {
          return _this2.loadModule(mod);
        }
      }))), _react.default.createElement("div", {
        className: "row ModuleList white z-depth-1"
      }, modules.map(function (mod, key) {
        return _react.default.createElement("div", {
          className: "col s6 text-left",
          style: {
            overflow: 'hidden'
          },
          key: mod.id
        }, _react.default.createElement("div", {
          style: {
            display: 'inline-block'
          }
        }, _react.default.createElement(_reactFontawesome.FontAwesomeIcon, {
          icon: "eraser",
          onClick: function onClick() {
            return _this2.removeModule(mod.id);
          }
        })), _react.default.createElement("div", {
          style: {
            display: 'inline-block',
            width: 48
          }
        }, mod.id));
      })), _get(_getPrototypeOf(ModuleServiceInfo.prototype), "render", this).call(this));
    }
  }]);

  return ModuleServiceInfo;
}(_Module2.default);

ModuleServiceInfo.Category = "Services";
var _default = ModuleServiceInfo;
exports.default = _default;