"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _Module2 = _interopRequireDefault(require("../Module"));

var _Form = _interopRequireDefault(require("../theme/Form.js"));

var _User = _interopRequireDefault(require("../../systems/services/User"));

var _Modal = _interopRequireDefault(require("../layout/Modal.js"));

require("./Login.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var LoginFormInputs = {
  object: {
    value: {
      Username: '',
      Password: ''
    }
  }
};
var RegisterFormInputs = {
  object: {
    value: {
      Username: '',
      Password: '',
      'Confirm Password': '',
      Email: ''
    }
  }
};

var UserLogin =
/*#__PURE__*/
function (_Module) {
  _inherits(UserLogin, _Module);

  function UserLogin(props) {
    var _this;

    _classCallCheck(this, UserLogin);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(UserLogin).call(this, props));
    _this.state = {
      username: '',
      password: ''
    };
    return _this;
  }

  _createClass(UserLogin, [{
    key: "register",
    value: function register(data) {
      var _this2 = this;

      _User.default.register({
        email: data.Email,
        username: data.Username,
        password: data.Password
      }).then(function (res) {
        _this2.login(data);
      });
    }
  }, {
    key: "login",
    value: function login(data) {
      var _this3 = this;

      _User.default.login({
        username: data.Username,
        password: data.Password
      }).then(function (res) {
        _this3.user.set(_User.default.me());

        _this3.forceUpdate();
      });
    }
  }, {
    key: "logout",
    value: function logout() {
      var _this4 = this;

      _User.default.logout().then(function () {
        _this4.user.set(_User.default.me());

        _this4.forceUpdate();
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this5 = this;

      var logged = _User.default.isLogged();

      if (!logged) return _react.default.createElement("div", {
        className: "Login"
      }, _react.default.createElement("button", {
        type: "button",
        className: "btn btn-secondary btn-sm",
        "data-toggle": "modal",
        "data-target": "#loginModal"
      }, "Login"), _react.default.createElement(_Modal.default, {
        id: "loginModal",
        title: "Sign in"
      }, this.state.register ? [_react.default.createElement(_Form.default, {
        key: 55,
        inputs: RegisterFormInputs,
        onSubmit: function onSubmit(data) {
          return _this5.register(data);
        },
        buttonText: "Register"
      }), _react.default.createElement("a", {
        className: "small",
        key: 56,
        onClick: function onClick() {
          return _this5.setState({
            register: false
          });
        }
      }, "Already a user ", _react.default.createElement("br", null), " Click to here")] : [_react.default.createElement(_Form.default, {
        key: 65,
        inputs: LoginFormInputs,
        onSubmit: function onSubmit(data) {
          return _this5.login(data);
        },
        buttonText: "Login"
      }), _react.default.createElement("a", {
        className: "small",
        key: 66,
        onClick: function onClick() {
          return _this5.setState({
            register: true
          });
        }
      }, "You don't have an account! ", _react.default.createElement("br", null), " Register here")]), _get(_getPrototypeOf(UserLogin.prototype), "render", this).call(this));else return _react.default.createElement("div", {
        className: "Logout"
      }, _react.default.createElement("span", null, "Logged in as ", _User.default.getName(), "!"), _react.default.createElement("button", {
        type: "button",
        className: "btn btn-secondary btn-sm small",
        onClick: function onClick() {
          return _this5.logout();
        }
      }, "Logout"), _get(_getPrototypeOf(UserLogin.prototype), "render", this).call(this));
    }
  }]);

  return UserLogin;
}(_Module2.default);

UserLogin.EditPosition = "top-center";
UserLogin.Outputs = {
  user: {}
};
var _default = UserLogin;
exports.default = _default;