import React from 'react';
import Module from '../Module';

import './base.css';

class Link extends Module {
	constructor(props) {
		super(props);
		this.state = {
		}
		this.ref.value = this.props.link || this.ref.value;
	}
	go(ref) {
		this.CoreSystem.go(ref);
	}

	render() {
		return <a href={this.RoutingSystem.getURL(this.ref.value)} target={this.props.target} className={`Link ${this.props.className}`}
				onClick={(e) => {
					if(!this.props.newTab) {
						this.go(this.ref.value);
						e.preventDefault();
					}
				}}>
				{super.render()}
			</a>;
	}
}

Link.EditPosition = "top-left";
Link.Inputs = {
	ref: {
		type: Module.Types.Text,
		defaultValue: "home"
	}
}
Link.Category = "Layout";

export default Link;